module.exports = {
  env: {
    browser: true,
    commonjs: true,
    es6: true,
    node: true
  },
  parserOptions: {
    ecmaVersion: 6,
    sourceType: 'module',
    ecmaFeatures: {
      legacyDecorators: true,
      modules: true
    }
  },
  extends: ['eslint:recommended', 'plugin:react/recommended'],
  parser: 'babel-eslint',
  plugins: ['react'],
  rules: {
    indent: ['off', 2],
    'linebreak-style': ['error', 'unix'],
    quotes: ['error', 'single', { allowTemplateLiterals: true }],
    semi: 'off',
    'no-console': 'off',
    'no-debugger': 'off',
    'no-useless-escape': 'warn',
    'no-unused-vars': 'warn',

    'react/jsx-key': 'warn',
    'react/prop-types': 'off' // state のプロパティにエラーを吐いてしまう(バグ？)
  }
}
