"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.cn = exports.assetLinkWidth = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _typestyle = require("typestyle");

var _core = require("@material-ui/core");

var _findAssetButton = _interopRequireDefault(require("./findAssetButton"));

var iconSize = 48;
var padding = 2;
var assetLinkWidth = iconSize + padding * 2;
exports.assetLinkWidth = assetLinkWidth;
var cn = {
  button: (0, _typestyle.style)({
    minWidth: assetLinkWidth,
    padding: padding
  }),
  icon: (0, _typestyle.style)({
    maxHeight: iconSize,
    width: iconSize
  })
};
exports.cn = cn;

var AssetLink =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(AssetLink, _React$Component);

  function AssetLink() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, AssetLink);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(AssetLink)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      name: '',
      iconUrl: ''
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleClick", function () {
      var _this$state = _this.state,
          name = _this$state.name,
          iconUrl = _this$state.iconUrl;
      if (!name) return;

      _this.props.onClick({
        name: name,
        iconUrl: iconUrl
      });
    });
    return _this;
  }

  (0, _createClass2.default)(AssetLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          name = _this$props.name,
          className = _this$props.className;
      var iconUrl = this.state.iconUrl;
      return _react.default.createElement(_core.Tooltip, {
        title: this.props.localization.editorCard.edit(name)
      }, _react.default.createElement(_core.Button, {
        variant: "outlined",
        className: (0, _typestyle.classes)(className, cn.button),
        disabled: !this.state.name,
        onClick: this.handleClick
      }, this.state.iconUrl ? _react.default.createElement("img", {
        src: iconUrl,
        alt: name,
        className: cn.icon
      }) : _react.default.createElement("span", {
        className: cn.icon
      }, name)));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (props.name !== state.name) {
        // まだ計算されていない
        var assetButton = (0, _findAssetButton.default)(props.asset, props.name);

        if (assetButton) {
          return {
            name: props.name,
            iconUrl: assetButton.iconUrl
          };
        }
      }

      return null;
    }
  }]);
  return AssetLink;
}(_react.default.Component);

exports.default = AssetLink;
(0, _defineProperty2.default)(AssetLink, "propTypes", {
  name: _propTypes.default.string.isRequired,
  asset: _propTypes.default.any.isRequired,
  className: _propTypes.default.string.isRequired,
  onClick: _propTypes.default.func.isRequired,
  localization: _propTypes.default.object.isRequired
});