"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findAssetButton;

function findAssetButton(asset, name) {
  return findRecursive(asset.buttons, name);
}

function findRecursive(assetButtons, name) {
  if (!Array.isArray(assetButtons)) return null;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = assetButtons[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;
      if (item.name === name) return item;
      var result = findRecursive(item.variations, name);
      if (result) return result;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return null;
}