"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _typestyle = require("typestyle");

var _reactDnd = require("react-dnd");

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _ArrowBack = _interopRequireDefault(require("@material-ui/icons/ArrowBack"));

var _dragTypes = _interopRequireDefault(require("../../utils/dragTypes"));

var _dec, _class, _class2, _temp;

var cn = {
  icon: (0, _typestyle.style)({
    borderWidth: 0,
    borderStyle: 'solid',
    borderColor: 'transparent',
    borderRadius: 2
  })
};

var getCn = function getCn(props) {
  return {
    iconDragOver: (0, _typestyle.style)({
      borderTopWidth: props.theme.spacing.unit,
      backgroundColor: props.theme.palette.disabledColor
    })
  };
};

var _TrashBox = (_dec = (0, _styles.withTheme)(), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2.default)(_TrashBox, _PureComponent);

  function _TrashBox() {
    (0, _classCallCheck2.default)(this, _TrashBox);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(_TrashBox).apply(this, arguments));
  }

  (0, _createClass2.default)(_TrashBox, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          showTrashes = _this$props.showTrashes,
          onClick = _this$props.onClick,
          connectDropTarget = _this$props.connectDropTarget;
      var isOver = this.props.isOver;
      return connectDropTarget(_react.default.createElement("div", null, _react.default.createElement(_IconButton.default, {
        className: (0, _typestyle.classes)(cn.icon, isOver && getCn(this.props).iconDragOver),
        onClick: onClick
      }, showTrashes ? _react.default.createElement(_ArrowBack.default, null) : _react.default.createElement(_Delete.default, null))));
    }
  }]);
  return _TrashBox;
}(_react.PureComponent), (0, _defineProperty2.default)(_class2, "propTypes", {
  theme: _propTypes.default.object.isRequired,
  showTrashes: _propTypes.default.bool.isRequired,
  putFile: _propTypes.default.func.isRequired,
  onClick: _propTypes.default.func.isRequired,
  connectDropTarget: _propTypes.default.func.isRequired,
  isOver: _propTypes.default.bool.isRequired
}), _temp)) || _class);

var spec = {
  drop: function drop(props, monitor) {
    var putFile = props.putFile;

    var _monitor$getItem = monitor.getItem(),
        files = _monitor$getItem.files;

    files.forEach(function (file) {
      var options = Object.assign({}, file.options, {
        isTrashed: !file.options.isTrashed
      });
      putFile(file, file.set({
        options: options
      }));
    });
    return {};
  }
};

var collect = function collect(connect, monitor) {
  return {
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver({
      shallow: true
    })
  };
};

var TrashBox = (0, _reactDnd.DropTarget)(_dragTypes.default.File, spec, collect)(_TrashBox);
var _default = TrashBox;
exports.default = _default;