"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makeFromFile;

var _ = require("./");

/**
 * @param file File|Blob
 * @return Promsie provides _File
 */
function makeFromFile(file) {
  if ((0, _.validateType)('text', file.type)) {
    return _.SourceFile.load(file);
  }

  if ((0, _.validateType)('blob', file.type)) {
    return _.BinaryFile.load(file);
  }

  return Promise.reject("Unknown File Type ".concat(file.type));
}