"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Provider;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _jss = require("jss");

var _JssProvider = _interopRequireDefault(require("react-jss/lib/JssProvider"));

var _jssPreset = _interopRequireDefault(require("@material-ui/core/styles/jssPreset"));

var _createGenerateClassName = _interopRequireDefault(require("@material-ui/core/styles/createGenerateClassName"));

var styleNode = document.createElement('style');
styleNode.id = 'insertion-point-jss';

if (!document.head) {
  throw new Error('document.head is not initialized');
}

document.head.insertBefore(styleNode, document.head.firstChild); // Configure JSS

var jss = (0, _jss.create)((0, _jssPreset.default)());
jss.options.createGenerateClassName = _createGenerateClassName.default;
jss.options.insertionPoint = document.getElementById('insertion-point-jss');

function Provider(props) {
  return _react.default.createElement(_JssProvider.default, {
    jss: jss
  }, props.children);
}

Provider.propTypes = {
  children: _propTypes.default.node.isRequired
};