"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.acceptedLanguages = exports.default = exports.defaultLanguage = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _includes = _interopRequireDefault(require("lodash/includes"));

var _en = _interopRequireDefault(require("./en"));

var _ja = _interopRequireDefault(require("./ja"));

var localizations = [_en.default, _ja.default];
var defaultLanguage = 'en-us';
exports.defaultLanguage = defaultLanguage;

var _default = function _default(languages) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    var _loop = function _loop() {
      var _lang = _step.value;

      var lang = _lang.toLowerCase();

      var hit = localizations.find(function (loc) {
        return (0, _includes.default)(loc.accept, lang);
      });

      if (hit) {
        return {
          v: hit
        };
      }
    };

    for (var _iterator = languages[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ret = _loop();

      if ((0, _typeof2.default)(_ret) === "object") return _ret.v;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return _en.default; // default
};

exports.default = _default;
var acceptedLanguages = localizations.map(function (_ref) {
  var accept = _ref.accept,
      native = _ref.native;
  return {
    accept: accept,
    native: native
  };
});
exports.acceptedLanguages = acceptedLanguages;