"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.critical = exports.error = exports.warning = exports.warn = exports.info = exports.debug = exports.log = void 0;

var _rollbar = _interopRequireDefault(require("rollbar"));

var NODE_ENV = 'development';

try {
  NODE_ENV = process.env.NODE_ENV; // portal 側で入れてくれる
} catch (error) {// 'development' のまま => 通知しない
}

var rollbar = new _rollbar.default({
  accessToken: '46185b6c483d46bea0cd066075b5cc0e',
  // [CAUTION] Used in Feeles/IDE as raw string
  captureUncaught: false,
  // ユーザーのコードを送信するだけなのでキャプチャしない
  captureUnhandledRejections: false,
  // ユーザーのコードを送信するだけなのでキャプチャしない
  filterTelemetry: function filterTelemetry(e) {
    // Any event that matches the test is *not* added to the queue.
    return e.type === 'network' && (e.body.subtype === 'xhr' || e.body.subtype === 'fetch') && /^https?:\/\/\w+\.googleapis\.com/.test(e.body.url) // GCP/Firebase のリクエストを除外
    ;
  },
  payload: {
    environment: NODE_ENV
  }
});

var log = function log() {
  return rollbar && rollbar.log.apply(rollbar, arguments);
};

exports.log = log;

var debug = function debug() {
  return rollbar && rollbar.debug.apply(rollbar, arguments);
};

exports.debug = debug;

var info = function info() {
  return rollbar && rollbar.info.apply(rollbar, arguments);
};

exports.info = info;

var warn = function warn() {
  return rollbar && rollbar.warn.apply(rollbar, arguments);
};

exports.warn = warn;

var warning = function warning() {
  return rollbar && rollbar.warning.apply(rollbar, arguments);
};

exports.warning = warning;

var error = function error() {
  return rollbar && rollbar.error.apply(rollbar, arguments);
};

exports.error = error;

var critical = function critical() {
  return rollbar && rollbar.critical.apply(rollbar, arguments);
};

exports.critical = critical;