# ブロードフェーズ


Matter.js には、高速化のために **ブロードフェーズ** が利用されているんだ  
それを目で見えるようにしたのが、黄色い枠だよ

## ブロードフェーズって？

あるオブジェクトと別のオブジェクトが重なっているか（ぶつかったか）というのは、  
動きを計算する上で、かかせない情報だよね

でも、画面上にあるオブジェクトをひとつひとつ計算していると、  
オブジェクトが 10 個なら、およそ 100 回.  
オブジェクトが 100 個なら、およそ 10000 回.  
オブジェクトが 1000 個なら、およそ 1000000 回...  
と、とってもたくさんのパターンを計算する必要があるんだ

そこで、 **絶対にぶつからないくらいに離れているオブジェクト同士は、計算を省略する** よ  
本来のオブジェクトは多角形（三角、四角、五角……）だけど、  
それらを **おおざっぱな形** （長方形にすることが多い）にしてから、計算するんだ  
この形は必ず **元の形より大きくなくちゃいけない** よ。  
ホントは重なってるのに、形が変わったせいで離れたらいけないからね
> この部分の計算を「ブロードフェーズ」と呼ぶよ🌟

ブロードフェーズが終わったら、「重なってるかも知れない」ものだけを集めて、  
ちゃんとした計算を行うよ
> この部分の計算を「ナローフェーズ」と呼ぶよ🌊


## ![改造する](broadphase/main.js)


## パラメータ
パラメータ | 意味 | 単位 | 最小 | 最大 
--- | --- | --- | --- | ---
isStatic | 静止するかどうか | フラグ | false | true 


[メニューに戻る](index.html)

