# カテゴリーごとのしょうとつ


色付きのオブジェクトは、  
同じ色の線をもつオブジェクトとしかぶつからないように  
**カテゴリー分け** されているよ


## ![改造する](collisionFiltering/main.js)


## 何ができるの？
カテゴリーごとのしょうとつを使いこなせるようになれば、  
「これとそれはぶつかる。でも、あれとこれはぶつからない」  
ということが、自由自在にできるようになるよ


今回の例では、 赤カテゴリー, 青カテゴリー, 緑カテゴリー,  
そして デフォルトカテゴリー（カテゴリーなし）という、  
４つのカテゴリーを使い分けているんだ


## パラメータ
パラメータ | 意味 | 単位 | 最小 | 最大 
--- | --- | --- | --- | ---
isStatic | 静止するかどうか | フラグ | false | true 
collisionFilter | | | |
category | そのオブジェクトのカテゴリー | ビットフラグ | `0x0001` (デフォルトカテゴリー) | 
mask | オブジェクトがしょうとつするカテゴリー |　ビットフラグ | `0x0000` (無) | `0xFFFF` (全て)  
render | | | |
strokeStyle | 線の色 | 色 | *"#000000"* (黒) | *"#FFFFFF"* (白)
fillStyle | 塗りつぶしの色 | 色 | *"#000000"* (黒) | *"#FFFFFF"* (白)
lineWidth | 線の太さ | px | 0 | Infinity

## | の意味
`defaultCategory | greenCategory` は、  
デフォルトカテゴリー **と、** 緑カテゴリー  
という意味を表しているよ

## ビットフラグの意味

ビットとは、 0 か 1 の情報しかもたない、情報の最小単位のこと  
`0x0001` は 16進数という特別な数字の書き方で、実際にはふつうの数字と同じだよ


[メニューに戻る](index.html)

